Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.emory.mathcs.backport.java.util.concurrent
Class ConcurrentSkipListMap

    java.lang.Object
      java.util.AbstractMap
          edu.emory.mathcs.backport.java.util.AbstractMap
              edu.emory.mathcs.backport.java.util.concurrent.ConcurrentSkipListMap

All Implemented Interfaces:
  java.lang.Cloneable, ConcurrentMap, ConcurrentNavigableMap, java.util.Map, NavigableMap, java.io.Serializable, java.util.SortedMap

public class ConcurrentSkipListMap
extends AbstractMap
implements ConcurrentNavigableMap, java.lang.Cloneable, java.io.Serializable

A scalable concurrent `ConcurrentNavigableMap` implementation. The map is sorted according to the natural ordering of its keys, or by a `Comparator` provided at map creation time, depending on which constructor is used.

This class implements a concurrent variant of SkipLists providing expected average log(n) time cost for the `containsKey`, `get`, `put` and `remove` operations and their variants. Insertion, removal, update, and access operations safely execute concurrently by multiple threads. Iterators are weakly consistent, returning elements reflecting the state of the map at some point at or since the creation of the iterator. They do not throw `ConcurrentModificationException`, and may proceed concurrently with other operations. Ascending key ordered views and their iterators are faster than descending ones.

All `Map.Entry` pairs returned by methods in this class and its views represent snapshots of mappings at the time they were produced. They do not support the `Entry.setValue` method. (Note however that it is possible to change mappings in the associated map using `put`, `putIfAbsent`, or `replace`, depending on exactly which effect you need.)

Beware that, unlike in most collections, the `size` method is not a constant-time operation. Because of the asynchronous nature of these maps, determining the current number of elements requires a traversal of the elements. Additionally, the bulk operations `putAll`, `equals`, and `clear` are not guaranteed to be performed atomically. For example, an iterator operating concurrently with a `putAll` operation might view only some of the added elements.

This class and its views and iterators implement all of the optional methods of the `Map` and `Iterator` interfaces. Like most other concurrent collections, this class does not permit the use of `null` keys or values because some null return values cannot be reliably distinguished from the absence of elements.

This class is a member of the Java Collections Framework.

Since:
  1.6
Author:
  Doug Lea
See Also:
  Serialized Form

Nested Class Summary

Nested classes inherited from class edu.emory.mathcs.backport.java.util.AbstractMap
`AbstractMap.SimpleEntry, AbstractMap.SimpleImmutableEntry`

Nested classes inherited from class java.util.Map
`java.util.Map.Entry`

Constructor Summary
`ConcurrentSkipListMap()` Constructs a new, empty map, sorted according to the natural ordering of the keys.
`ConcurrentSkipListMap(java.util.Comparator comparator)` Constructs a new, empty map, sorted according to the specified comparator.
`ConcurrentSkipListMap(java.util.Map m)` Constructs a new map containing the same mappings as the given map, sorted according to the natural ordering of the keys.
`ConcurrentSkipListMap(java.util.SortedMap m)` Constructs a new map containing the same mappings and using the same ordering as the specified sorted map.

Method Summary
`java.util.Map.Entry` | `ceilingEntry(java.lang.Object key)` Returns a key-value mapping associated with the least key greater than or equal to the given key, or `null` if there is no such entry.
`java.lang.Object` | `ceilingKey(java.lang.Object key)` Returns the least key greater than or equal to the given key, or if there is no such key.
`void` | `clear()` Removes all of the mappings from this map.
`java.lang.Object` | `clone()` Returns a shallow copy of this `ConcurrentSkipListMap` instance.
`java.util.Comparator` | `comparator()`
`boolean` | `containsKey(java.lang.Object key)` Returns `true` if this map contains a mapping for the specified key.
`boolean` | `containsValue(java.lang.Object value)` Returns `true` if this map maps one or more keys to the specified value.
`NavigableSet` | `descendingKeySet()` Returns a reverse order `NavigableSet` view of the keys contained in this map.
`NavigableMap` | `descendingMap()` Returns a reverse order view of the mappings contained in this map.
`java.util.Set` | `entrySet()` Returns a `Set` view of the mappings contained in this map.
`boolean` | `equals(java.lang.Object o)` Compares the specified object with this map for equality.
`java.util.Map.Entry` | `firstEntry()` Returns a key-value mapping associated with the least key in this map, or `null` if the map is empty.
`java.lang.Object` | `firstKey()`
`java.util.Map.Entry` | `floorEntry(java.lang.Object key)` Returns a key-value mapping associated with the greatest key less than or equal to the given key, or `null` if there is no such key.
`java.lang.Object` | `floorKey(java.lang.Object key)` Returns the greatest key less than or equal to the given key, or if there is no such key.
`java.lang.Object` | `get(java.lang.Object key)` Returns the value to which the specified key is mapped, or if this map contains no mapping for the key.
`java.util.SortedMap` | `headMap(java.lang.Object toKey)`
`NavigableMap` | `headMap(java.lang.Object toKey, boolean inclusive)` Returns a view of the portion of this map whose keys are less than (or equal to, if is true) .
`java.util.Map.Entry` | `higherEntry(java.lang.Object key)` Returns a key-value mapping associated with the least key strictly greater than the given key, or `null` if there is no such key.
`java.lang.Object` | `higherKey(java.lang.Object key)` Returns the least key strictly greater than the given key, or if there is no such key.
`boolean` | `isEmpty()` Returns `true` if this map contains no key-value mappings.
`java.util.Set` | `keySet()` Returns a `NavigableSet` view of the keys contained in this map.
`java.util.Map.Entry` | `lastEntry()` Returns a key-value mapping associated with the greatest key in this map, or `null` if the map is empty.
`java.lang.Object` | `lastKey()`
`java.util.Map.Entry` | `lowerEntry(java.lang.Object key)` Returns a key-value mapping associated with the greatest key strictly less than the given key, or `null` if there is no such key.
`java.lang.Object` | `lowerKey(java.lang.Object key)` Returns the greatest key strictly less than the given key, or if there is no such key.
`NavigableSet` | `navigableKeySet()` Returns a `NavigableSet` view of the keys contained in this map.
`java.util.Map.Entry` | `pollFirstEntry()` Removes and returns a key-value mapping associated with the least key in this map, or `null` if the map is empty.
`java.util.Map.Entry` | `pollLastEntry()` Removes and returns a key-value mapping associated with the greatest key in this map, or `null` if the map is empty.
`java.lang.Object` | `put(java.lang.Object key, java.lang.Object value)` Associates the specified value with the specified key in this map.
`java.lang.Object` | `putIfAbsent(java.lang.Object key, java.lang.Object value)` If the specified key is not already associated with a value, associate it with the given value. This is equivalent to
       if (!map.containsKey(key))
           return map.put(key, value);
       else
           return map.get(key);
except that the action is performed atomically.
`java.lang.Object` | `remove(java.lang.Object key)` Removes the mapping for the specified key from this map if present.
`boolean` | `remove(java.lang.Object key, java.lang.Object value)` Removes the entry for a key only if currently mapped to a given value. This is equivalent to
       if (map.containsKey(key) && map.get(key).equals(value)) {
           map.remove(key);
           return true;
       } else return false;
except that the action is performed atomically.
`java.lang.Object` | `replace(java.lang.Object key, java.lang.Object value)` Replaces the entry for a key only if currently mapped to some value. This is equivalent to
       if (map.containsKey(key)) {
           return map.put(key, value);
       } else return null;
except that the action is performed atomically.
`boolean` | `replace(java.lang.Object key, java.lang.Object oldValue, java.lang.Object newValue)` Replaces the entry for a key only if currently mapped to a given value. This is equivalent to
       if (map.containsKey(key) && map.get(key).equals(oldValue)) {
           map.put(key, newValue);
           return true;
       } else return false;
except that the action is performed atomically.
`int` | `size()` Returns the number of key-value mappings in this map.
`NavigableMap` | `subMap(java.lang.Object fromKey, boolean fromInclusive, java.lang.Object toKey, boolean toInclusive)` Returns a view of the portion of this map whose keys range from to .
`java.util.SortedMap` | `subMap(java.lang.Object fromKey, java.lang.Object toKey)`
`java.util.SortedMap` | `tailMap(java.lang.Object fromKey)`
`NavigableMap` | `tailMap(java.lang.Object fromKey, boolean inclusive)` Returns a view of the portion of this map whose keys are greater than (or equal to, if is true) .
`java.util.Collection` | `values()` Returns a `Collection` view of the values contained in this map.

Methods inherited from class java.util.AbstractMap
`hashCode, putAll, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`hashCode, putAll`

Constructor Detail

### ConcurrentSkipListMap

    public ConcurrentSkipListMap()

  Constructs a new, empty map, sorted according to the natural ordering of the keys.

### ConcurrentSkipListMap

    public ConcurrentSkipListMap(java.util.Comparator comparator)

  Constructs a new, empty map, sorted according to the specified comparator.

Parameters:
  `comparator` - the comparator that will be used to order this map. If `null`, the natural ordering of the keys will be used.

### ConcurrentSkipListMap

    public ConcurrentSkipListMap(java.util.Map m)

  Constructs a new map containing the same mappings as the given map, sorted according to the natural ordering of the keys.

Parameters:
  `m` - the map whose mappings are to be placed in this map
Throws:
  `java.lang.ClassCastException` - if the keys in `m` are not `Comparable`, or are not mutually comparable
  `java.lang.NullPointerException` - if the specified map or any of its keys or values are null

### ConcurrentSkipListMap

    public ConcurrentSkipListMap(java.util.SortedMap m)

  Constructs a new map containing the same mappings and using the same ordering as the specified sorted map.

Parameters:
  `m` - the sorted map whose mappings are to be placed in this map, and whose comparator is to be used to sort this map
Throws:
  `java.lang.NullPointerException` - if the specified sorted map or any of its keys or values are null

Method Detail

### clone

    public java.lang.Object clone()

  Returns a shallow copy of this `ConcurrentSkipListMap` instance. (The keys and values themselves are not cloned.)

  Returns:
    a shallow copy of this map

### containsKey

    public boolean containsKey(java.lang.Object key)

  Returns `true` if this map contains a mapping for the specified key.

  Specified by:
    `containsKey` in interface `java.util.Map`
  Parameters:
    `key` - key whose presence in this map is to be tested
  Returns:
    `true` if this map contains a mapping for the specified key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null

### get

    public java.lang.Object get(java.lang.Object key)

  Returns the value to which the specified key is mapped, or if this map contains no mapping for the key.

  More formally, if this map contains a mapping from a key to a value such that compares equal to according to the map's ordering, then this method returns ; otherwise it returns . (There can be at most one such mapping.)

  Specified by:
    `get` in interface `java.util.Map`
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null

### put

    public java.lang.Object put(java.lang.Object key,
                                java.lang.Object value)

  Associates the specified value with the specified key in this map. If the map previously contained a mapping for the key, the old value is replaced.

  Specified by:
    `put` in interface `java.util.Map`
  Parameters:
    `key` - key with which the specified value is to be associated
    `value` - value to be associated with the specified key
  Returns:
    the previous value associated with the specified key, or `null` if there was no mapping for the key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key or value is null

### remove

    public java.lang.Object remove(java.lang.Object key)

  Removes the mapping for the specified key from this map if present.

  Specified by:
    `remove` in interface `java.util.Map`
  Parameters:
    `key` - key for which mapping should be removed
  Returns:
    the previous value associated with the specified key, or `null` if there was no mapping for the key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null

### containsValue

    public boolean containsValue(java.lang.Object value)

  Returns `true` if this map maps one or more keys to the specified value. This operation requires time linear in the map size.

  Specified by:
    `containsValue` in interface `java.util.Map`
  Parameters:
    `value` - value whose presence in this map is to be tested
  Returns:
    `true` if a mapping to `value` exists; `false` otherwise
  Throws:
    `java.lang.NullPointerException` - if the specified value is null

### size

    public int size()

  Returns the number of key-value mappings in this map. If this map contains more than `Integer.MAX_VALUE` elements, it returns `Integer.MAX_VALUE`.

  Beware that, unlike in most collections, this method is NOT a constant-time operation. Because of the asynchronous nature of these maps, determining the current number of elements requires traversing them all to count them. Additionally, it is possible for the size to change during execution of this method, in which case the returned result will be inaccurate. Thus, this method is typically not very useful in concurrent applications.

  Specified by:
    `size` in interface `java.util.Map`
  Returns:
    the number of elements in this map

### isEmpty

    public boolean isEmpty()

  Returns `true` if this map contains no key-value mappings.

  Specified by:
    `isEmpty` in interface `java.util.Map`
  Returns:
    `true` if this map contains no key-value mappings

### clear

    public void clear()

  Removes all of the mappings from this map.

  Specified by:
    `clear` in interface `java.util.Map`

### keySet

    public java.util.Set keySet()

  Returns a `NavigableSet` view of the keys contained in this map. The set's iterator returns the keys in ascending order. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from the map, via the , , , , and operations. It does not support the or operations.

  The view's is a "weakly consistent" iterator that will never throw `ConcurrentModificationException`, and guarantees to traverse elements as they existed upon construction of the iterator, and may (but is not guaranteed to) reflect any modifications subsequent to construction.

  This method is equivalent to method .

  Specified by:
    `keySet` in interface `ConcurrentNavigableMap`
  Overrides:
    `keySet` in class `AbstractMap`
  Returns:
    a navigable set view of the keys in this map

### navigableKeySet

    public NavigableSet navigableKeySet()

  Description copied from interface: `ConcurrentNavigableMap`
  Returns a `NavigableSet` view of the keys contained in this map. The set's iterator returns the keys in ascending order. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from the map, via the , , , , and operations. It does not support the or operations.

  The view's is a "weakly consistent" iterator that will never throw `ConcurrentModificationException`, and guarantees to traverse elements as they existed upon construction of the iterator, and may (but is not guaranteed to) reflect any modifications subsequent to construction.

  Specified by:
    `navigableKeySet` in interface `ConcurrentNavigableMap`
  Returns:
    a navigable set view of the keys in this map

### values

    public java.util.Collection values()

  Returns a `Collection` view of the values contained in this map. The collection's iterator returns the values in ascending order of the corresponding keys. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. The collection supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations.

  The view's `iterator` is a "weakly consistent" iterator that will never throw `ConcurrentModificationException`, and guarantees to traverse elements as they existed upon construction of the iterator, and may (but is not guaranteed to) reflect any modifications subsequent to construction.

  Specified by:
    `values` in interface `java.util.Map`

### entrySet

    public java.util.Set entrySet()

  Returns a `Set` view of the mappings contained in this map. The set's iterator returns the entries in ascending key order. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations.

  The view's `iterator` is a "weakly consistent" iterator that will never throw `ConcurrentModificationException`, and guarantees to traverse elements as they existed upon construction of the iterator, and may (but is not guaranteed to) reflect any modifications subsequent to construction.

  The `Map.Entry` elements returned by `iterator.next()` do not support the `setValue` operation.

  Specified by:
    `entrySet` in interface `java.util.Map`
  Returns:
    a set view of the mappings contained in this map, sorted in ascending key order

### descendingMap

    public NavigableMap descendingMap()

  Description copied from interface: `ConcurrentNavigableMap`
  Returns a reverse order view of the mappings contained in this map. The descending map is backed by this map, so changes to the map are reflected in the descending map, and vice-versa.

  The returned map has an ordering equivalent to ``Collections.reverseOrder`(comparator())`. The expression returns a view of essentially equivalent to .

  Specified by:
    `descendingMap` in interface `ConcurrentNavigableMap`
  Returns:
    a reverse order view of this map

### descendingKeySet

    public NavigableSet descendingKeySet()

  Description copied from interface: `ConcurrentNavigableMap`
  Returns a reverse order `NavigableSet` view of the keys contained in this map. The set's iterator returns the keys in descending order. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from the map, via the , , , , and operations. It does not support the or operations.

  The view's is a "weakly consistent" iterator that will never throw `ConcurrentModificationException`, and guarantees to traverse elements as they existed upon construction of the iterator, and may (but is not guaranteed to) reflect any modifications subsequent to construction.

  Specified by:
    `descendingKeySet` in interface `ConcurrentNavigableMap`
  Returns:
    a reverse order navigable set view of the keys in this map

### equals

    public boolean equals(java.lang.Object o)

  Compares the specified object with this map for equality. Returns `true` if the given object is also a map and the two maps represent the same mappings. More formally, two maps `m1` and `m2` represent the same mappings if `m1.entrySet().equals(m2.entrySet())`. This operation may return misleading results if either map is concurrently modified during execution of this method.

  Specified by:
    `equals` in interface `java.util.Map`
  Parameters:
    `o` - object to be compared for equality with this map
  Returns:
    `true` if the specified object is equal to this map

### putIfAbsent

    public java.lang.Object putIfAbsent(java.lang.Object key,
                                        java.lang.Object value)

  If the specified key is not already associated with a value, associate it with the given value. This is equivalent to

         if (!map.containsKey(key))
             return map.put(key, value);
         else
             return map.get(key);

  except that the action is performed atomically.

  Specified by:
    `putIfAbsent` in interface `ConcurrentMap`
  Parameters:
    `key` - key with which the specified value is to be associated
    `value` - value to be associated with the specified key
  Returns:
    the previous value associated with the specified key, or `null` if there was no mapping for the key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key or value is null

### remove

    public boolean remove(java.lang.Object key,
                          java.lang.Object value)

  Removes the entry for a key only if currently mapped to a given value. This is equivalent to

         if (map.containsKey(key) && map.get(key).equals(value)) {
             map.remove(key);
             return true;
         } else return false;

  except that the action is performed atomically.

  Specified by:
    `remove` in interface `ConcurrentMap`
  Parameters:
    `key` - key with which the specified value is associated
    `value` - value expected to be associated with the specified key
  Returns:
    `true` if the value was removed
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null

### replace

    public boolean replace(java.lang.Object key,
                           java.lang.Object oldValue,
                           java.lang.Object newValue)

  Replaces the entry for a key only if currently mapped to a given value. This is equivalent to

         if (map.containsKey(key) && map.get(key).equals(oldValue)) {
             map.put(key, newValue);
             return true;
         } else return false;

  except that the action is performed atomically.

  Specified by:
    `replace` in interface `ConcurrentMap`
  Parameters:
    `key` - key with which the specified value is associated
    `oldValue` - value expected to be associated with the specified key
    `newValue` - value to be associated with the specified key
  Returns:
    `true` if the value was replaced
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if any of the arguments are null

### replace

    public java.lang.Object replace(java.lang.Object key,
                                    java.lang.Object value)

  Replaces the entry for a key only if currently mapped to some value. This is equivalent to

         if (map.containsKey(key)) {
             return map.put(key, value);
         } else return null;

  except that the action is performed atomically.

  Specified by:
    `replace` in interface `ConcurrentMap`
  Parameters:
    `key` - key with which the specified value is associated
    `value` - value to be associated with the specified key
  Returns:
    the previous value associated with the specified key, or `null` if there was no mapping for the key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key or value is null

### comparator

    public java.util.Comparator comparator()

  Specified by:
    `comparator` in interface `java.util.SortedMap`

### firstKey

    public java.lang.Object firstKey()

  Specified by:
    `firstKey` in interface `java.util.SortedMap`
  Throws:
    `java.util.NoSuchElementException`

### lastKey

    public java.lang.Object lastKey()

  Specified by:
    `lastKey` in interface `java.util.SortedMap`
  Throws:
    `java.util.NoSuchElementException`

### subMap

    public NavigableMap subMap(java.lang.Object fromKey,
                               boolean fromInclusive,
                               java.lang.Object toKey,
                               boolean toInclusive)

  Description copied from interface: `NavigableMap`
  Returns a view of the portion of this map whose keys range from to . If and are equal, the returned map is empty unless and are both true. The returned map is backed by this map, so changes in the returned map are reflected in this map, and vice-versa. The returned map supports all optional map operations that this map supports.

  The returned map will throw an on an attempt to insert a key outside of its range, or to construct a submap either of whose endpoints lie outside its range.

  Specified by:
    `subMap` in interface `ConcurrentNavigableMap`
  Throws:
    `java.lang.ClassCastException` - if and cannot be compared to one another using this map's comparator (or, if the map has no comparator, using natural ordering). Implementations may, but are not required to, throw this exception if or cannot be compared to keys currently in the map.
    `java.lang.NullPointerException` - if or is null
    `java.lang.IllegalArgumentException` - if is greater than ; or if this map itself has a restricted range, and or lies outside the bounds of the range

### headMap

    public NavigableMap headMap(java.lang.Object toKey,
                                boolean inclusive)

  Description copied from interface: `NavigableMap`
  Returns a view of the portion of this map whose keys are less than (or equal to, if is true) . The returned map is backed by this map, so changes in the returned map are reflected in this map, and vice-versa. The returned map supports all optional map operations that this map supports.

  The returned map will throw an on an attempt to insert a key outside its range.

  Specified by:
    `headMap` in interface `ConcurrentNavigableMap`
  Throws:
    `java.lang.ClassCastException` - if is not compatible with this map's comparator (or, if the map has no comparator, if does not implement `Comparable`). Implementations may, but are not required to, throw this exception if cannot be compared to keys currently in the map.
    `java.lang.NullPointerException` - if is null
    `java.lang.IllegalArgumentException` - if this map itself has a restricted range, and lies outside the bounds of the range

### tailMap

    public NavigableMap tailMap(java.lang.Object fromKey,
                                boolean inclusive)

  Description copied from interface: `NavigableMap`
  Returns a view of the portion of this map whose keys are greater than (or equal to, if is true) . The returned map is backed by this map, so changes in the returned map are reflected in this map, and vice-versa. The returned map supports all optional map operations that this map supports.

  The returned map will throw an on an attempt to insert a key outside its range.

  Specified by:
    `tailMap` in interface `ConcurrentNavigableMap`
  Throws:
    `java.lang.ClassCastException` - if is not compatible with this map's comparator (or, if the map has no comparator, if does not implement `Comparable`). Implementations may, but are not required to, throw this exception if cannot be compared to keys currently in the map.
    `java.lang.NullPointerException` - if is null
    `java.lang.IllegalArgumentException` - if this map itself has a restricted range, and lies outside the bounds of the range

### subMap

    public java.util.SortedMap subMap(java.lang.Object fromKey,
                                      java.lang.Object toKey)

  Description copied from interface: `NavigableMap`

  Equivalent to .

  Specified by:
    `subMap` in interface `ConcurrentNavigableMap`
  Throws:
    `java.lang.ClassCastException`
    `java.lang.NullPointerException` - if or is null
    `java.lang.IllegalArgumentException`

### headMap

    public java.util.SortedMap headMap(java.lang.Object toKey)

  Description copied from interface: `NavigableMap`

  Equivalent to .

  Specified by:
    `headMap` in interface `ConcurrentNavigableMap`
  Throws:
    `java.lang.ClassCastException`
    `java.lang.NullPointerException` - if is null
    `java.lang.IllegalArgumentException`

### tailMap

    public java.util.SortedMap tailMap(java.lang.Object fromKey)

  Description copied from interface: `NavigableMap`

  Equivalent to .

  Specified by:
    `tailMap` in interface `ConcurrentNavigableMap`
  Throws:
    `java.lang.ClassCastException`
    `java.lang.NullPointerException` - if is null
    `java.lang.IllegalArgumentException`

### lowerEntry

    public java.util.Map.Entry lowerEntry(java.lang.Object key)

  Returns a key-value mapping associated with the greatest key strictly less than the given key, or `null` if there is no such key. The returned entry does not support the `Entry.setValue` method.

  Specified by:
    `lowerEntry` in interface `NavigableMap`
  Parameters:
    `key` - the key
  Returns:
    an entry with the greatest key less than , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null

### lowerKey

    public java.lang.Object lowerKey(java.lang.Object key)

  Description copied from interface: `NavigableMap`
  Returns the greatest key strictly less than the given key, or if there is no such key.

  Specified by:
    `lowerKey` in interface `NavigableMap`
  Parameters:
    `key` - the key
  Returns:
    the greatest key less than , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null

### floorEntry

    public java.util.Map.Entry floorEntry(java.lang.Object key)

  Returns a key-value mapping associated with the greatest key less than or equal to the given key, or `null` if there is no such key. The returned entry does not support the `Entry.setValue` method.

  Specified by:
    `floorEntry` in interface `NavigableMap`
  Parameters:
    `key` - the key
  Returns:
    an entry with the greatest key less than or equal to , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null

### floorKey

    public java.lang.Object floorKey(java.lang.Object key)

  Description copied from interface: `NavigableMap`
  Returns the greatest key less than or equal to the given key, or if there is no such key.

  Specified by:
    `floorKey` in interface `NavigableMap`
  Parameters:
    `key` - the key
  Returns:
    the greatest key less than or equal to , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null

### ceilingEntry

    public java.util.Map.Entry ceilingEntry(java.lang.Object key)

  Returns a key-value mapping associated with the least key greater than or equal to the given key, or `null` if there is no such entry. The returned entry does not support the `Entry.setValue` method.

  Specified by:
    `ceilingEntry` in interface `NavigableMap`
  Parameters:
    `key` - the key
  Returns:
    an entry with the least key greater than or equal to , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null

### ceilingKey

    public java.lang.Object ceilingKey(java.lang.Object key)

  Description copied from interface: `NavigableMap`
  Returns the least key greater than or equal to the given key, or if there is no such key.

  Specified by:
    `ceilingKey` in interface `NavigableMap`
  Parameters:
    `key` - the key
  Returns:
    the least key greater than or equal to , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null

### higherEntry

    public java.util.Map.Entry higherEntry(java.lang.Object key)

  Returns a key-value mapping associated with the least key strictly greater than the given key, or `null` if there is no such key. The returned entry does not support the `Entry.setValue` method.

  Specified by:
    `higherEntry` in interface `NavigableMap`
  Parameters:
    `key` - the key
  Returns:
    an entry with the least key greater than , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null

### higherKey

    public java.lang.Object higherKey(java.lang.Object key)

  Description copied from interface: `NavigableMap`
  Returns the least key strictly greater than the given key, or if there is no such key.

  Specified by:
    `higherKey` in interface `NavigableMap`
  Parameters:
    `key` - the key
  Returns:
    the least key greater than , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null

### firstEntry

    public java.util.Map.Entry firstEntry()

  Returns a key-value mapping associated with the least key in this map, or `null` if the map is empty. The returned entry does not support the `Entry.setValue` method.

  Specified by:
    `firstEntry` in interface `NavigableMap`
  Returns:
    an entry with the least key, or if this map is empty

### lastEntry

    public java.util.Map.Entry lastEntry()

  Returns a key-value mapping associated with the greatest key in this map, or `null` if the map is empty. The returned entry does not support the `Entry.setValue` method.

  Specified by:
    `lastEntry` in interface `NavigableMap`
  Returns:
    an entry with the greatest key, or if this map is empty

### pollFirstEntry

    public java.util.Map.Entry pollFirstEntry()

  Removes and returns a key-value mapping associated with the least key in this map, or `null` if the map is empty. The returned entry does not support the `Entry.setValue` method.

  Specified by:
    `pollFirstEntry` in interface `NavigableMap`
  Returns:
    the removed first entry of this map, or if this map is empty

### pollLastEntry

    public java.util.Map.Entry pollLastEntry()

  Removes and returns a key-value mapping associated with the greatest key in this map, or `null` if the map is empty. The returned entry does not support the `Entry.setValue` method.

  Specified by:
    `pollLastEntry` in interface `NavigableMap`
  Returns:
    the removed last entry of this map, or if this map is empty

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD